/**
 * @file
 * @brief RThread class implementation
 */
#pragma GCC diagnostic ignored "-Wold-style-cast"
#pragma GCC diagnostic ignored "-Wzero-as-null-pointer-constant"
#pragma GCC diagnostic ignored "-Weffc++"
#pragma GCC diagnostic ignored "-Wsign-conversion"
#pragma GCC diagnostic ignored "-Wconversion"
#pragma GCC diagnostic ignored "-Wcast-qual"
#include "RThread.hpp"
#include "TThread.h"
#include "TTimeStamp.h"
#pragma GCC diagnostic warning "-Wold-style-cast"
#pragma GCC diagnostic warning "-Wzero-as-null-pointer-constant"
#pragma GCC diagnostic warning "-Weffc++"
#pragma GCC diagnostic warning "-Wsign-conversion"
#pragma GCC diagnostic warning "-Wconversion"
#pragma GCC diagnostic warning "-Wcast-qual"

RThread::RThread(const std::string name) :
    fStopFlag(false),
    fPauseFlag(false),
    fName(name),
    fThread(nullptr)
{
}

RThread::~RThread()
{
    Stop();
    delete fStart;
    delete fStop;
    if(fThread)
    {
        const int ret = TThread::Delete(fThread);
        if(ret == 0)
        {
            fThread = nullptr;
            TThread::Printf("Deleted %s", fName.c_str());
        }
        else
        {
            TThread::Printf("Incorrectly deleted %s", fName.c_str());
        }
    }
    else
    {
        TThread::Printf("Deleted %s", fName.c_str());
    }
}

int RThread::Start() {
    if (fThread == nullptr)
    {
        delete fStart;
        fStart = new TTimeStamp();
        TThread::Printf("Starting %s", fName.c_str());
        fThread = new TThread(fName.c_str(), static_cast<void*(*) (void *)>(&ThreadHandle), static_cast<void*>(this));
        fStopFlag = false;
        //We do not set the pause flag to false, to know if we are restoring from a Pause
        return fThread->Run();
	}
	else {
        if(fThread->GetState()==TThread::kRunningState)
		{
            TThread::Printf("Thread %s already running.", fName.c_str());
			return 0;
		}
		else
		{
            if(!fPauseFlag)
            {
                delete fStart;
                fStart = new TTimeStamp();
            }
            TThread::Printf("Thread %s already existing. Restarting ...", fName.c_str());
            fStopFlag = false;
            fPauseFlag = false;
            return fThread->Run();
		}
	}
	return 0;
}

int RThread::Join() {
    if(fThread)
    {
        fThread->Join();
        fStopFlag = false;
        fPauseFlag = false;
		return 1;
	}
	return 0;
}

int RThread::Pause() {
    fPauseFlag = true;
    const int ret=Join();
    if(ret)
    {
        TThread::Printf("%s paused.", fName.c_str());
    }
    return ret;
}

int RThread::Stop() {
    if(!IsRunning()) return Join();
    fStopFlag = true;
    fPauseFlag = false;
    delete fStop;
    fStop = new TTimeStamp();
	const int ret=Join();
    if(ret)
    {
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
        TThread::Printf("%s finished.", fName.c_str());
        TThread::Printf("Start: %s", fStart->AsString());
        TThread::Printf("Stop:  %s", fStop->AsString());
    }
	return ret;
}

int RThread::Kill()
{
    if(fThread)
    {
        fThread->Kill();
        const int ret = TThread::Delete(fThread);
		if(ret == 0)
		{
            fThread = nullptr;
            fStopFlag = false;
            fPauseFlag = false;
            TThread::Printf("Thread %s killed.", fName.c_str());
		}
		else
		{
            TThread::Printf("Thread %s was not deleted correctly. Threads still existing: %d", fName.c_str(), TThread::Exists());
		}
		return 1;
	}      
	return 0;
}

int RThread::IsRunning() const
{
    return fThread && fThread->GetState()==TThread::kRunningState;
}

void RThread::ThreadFunction()
{
}

void *RThread::ThreadHandle(void *ptr) {
    RThread* const thread = static_cast<RThread *>(ptr);
    thread->ThreadFunction();
    return nullptr;
}

void RThread::Sleep(ULong_t secs, ULong_t nanos)
{
    if(fThread) fThread->Sleep(secs, nanos);
}
