/**
 * @file
 * @brief Keysight wrapper controller class declaration
 */
#ifndef THKEYSIGHT_HPP
#define THKEYSIGHT_HPP

#ifdef __ROOTCLING__
#include "../usb/Keysight.hpp"
#else
#include "Keysight.hpp"
#endif
//#include "TMutex.h"
#include <RQ_OBJECT.h>
//#include "RThread.hpp"

/**
 * @brief The Keysight wrapper controller class
 *
 * It is interactive, can be controlled by ROOT terminal thanks to RQ_OBJECT
 *
 */
class ThKeysight : public Keysight//, public RThread
{
    RQ_OBJECT("ThKeysight")
public:
    /**
     * @brief Wrapped Keysight constructor, opens the device
     * @param vendor the vendor id
     * @param id the product id
     * @note If an error is found, fValid is set to false and fDevice to nullptr
     */
    ThKeysight(const uint32_t vendor, const uint32_t id);

    virtual ~ThKeysight();

    //TMutex fMutex{};                ///< communication mutex
};

#endif // THKEYSIGHT_HPP
