/**
 * @file
 * @brief utils function implementations
 */

#include "utils.hpp"
#include <sstream>
#include <chrono>
#include <iomanip>

std::string format_duration( const int64_t milli )
{
    using namespace std::chrono;
    auto ms = milliseconds(milli);
    auto secs = duration_cast<seconds>(ms);
    ms -= duration_cast<milliseconds>(secs);
    auto mins = duration_cast<minutes>(secs);
    secs -= duration_cast<seconds>(mins);
    //auto hour = duration_cast<hours>(mins);
    //mins -= duration_cast<minutes>(hour);

    std::stringstream ss;
    //ss << hour.count() << " Hours : " << mins.count() << " Minutes : " << secs.count() << " Seconds : " << ms.count() << " Milliseconds";
    ss << std::setfill ( '0' ) << std::setw (2) << mins.count() << ":" <<  std::setw (2) << secs.count() << "." <<   std::setw (2) << ms.count()/10;
    return ss.str();
}
